#ifndef gf_included_Map_h
#define gf_included_Map_h

#include "Level.h"
#include "list.h"

struct Kmap
{
 bool AnimateBusy;  //If this flag is set, it means that the Painter is still busy
                    //and that I shouldn't be continuing tile interactions just yet.
       
 TList PlayList;  //List of the tiles on the board.
 Level aLevel;    //The board itself. 
};

typedef struct Kmap KMap;

KMap LoadMap(char* FileName);
//This function loads the list of tiles and the board.  If you wanna see how I read
//the data from the level files, this would be the place to go.
KMap MoveNorth(KMap theMap);
//This is called when the player wants to move north.
KMap MoveWest(KMap theMap);
//Similar.
KMap MoveSouth(KMap theMap);
KMap MoveEast(KMap theMap);
KMap Interaction(KMap theMap);
//This runs the next round of interactions between tiles on the board.  
KMap CheckAnimation(KMap theMap);
//This checks to see if the Painter X, Y are caught up with each Tile's new X, Y position.
//If it's still busy, it sets the flag for it.
bool Winner(KMap theMap);
//This informs us of winning
bool Loser(KMap theMap);
//and this of losing.

#endif
