#ifndef gf_included_Menu_h
#define gf_included_Menu_h

#define STITLE 0
#define SHELP1 1
#define SHELP2 2
#define SHELP3 3
#define SWORLD 4
#define SDONE 5



//This function loads the worlds which will be used in the game.
//Currently I have only 1 world.
void LoadWorlds();

//This tells the Painter and the Driver what Screen we're currently on
//that way it can properly handle key input and paint the right thing.
int GetScreen();

//Puts the player cursor where it's needed, depending on the screen.
void IncreaseMenuOption();
void DecreaseMenuOption();

//Tells me if the player is playing the game right now or not.
bool InGame();

//It goes to the appropriate screen based on the option selected.
void ProcessOption();

//It goes back to a previous screen.  Returns true if the user just quit.
bool DeProcessOption();

//Get the world name.
char* GetWorldName();

//Level name being played.
char* GetLevelName();

//The filename to load the appropriate map.
char* GetLevelByFile();

//Takes us back to the menu.
void OutOfGame();

//These gives the coordinates to the Painter on where to draw the icon.
double GetMenuX();
double GetMenuY();
double GetWorldX();
double GetWorldY();

#endif
