#ifndef gf_included_Particles_h
#define gf_included_Particles_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

struct particles
{
 double LifeLeft;
 double Age;
 double R;
 double G;
 double B;
 
 double rX;  //My particles have a lifetime, a colour, and position/velocity/acceleration.
 double rY;  //Depending on the acceleration and starting velocities, we can get some interesting
 double rZ;  //looking particles.  
 
 double vX;
 double vY;
 double vZ;
 
 double aX;
 double aY;
 double aZ;      
};

typedef struct particles Particle;
#define PARTICLELENGTH 50

//I only have three particle effects for this game.
//I've got fire for my enemies, fireworks for my exit, and swirlies for my crystals.

void InitializeFire();
void InitializeSkidMark();
void InitializeExit();
void InitializeLights();
void PaintFire(bool Update);
bool PaintSkidMark(bool Update);
void PaintLights(bool Update);
void PaintFinish(bool Update);
void InitializeSystems(GLuint PFire);
void RegisterSystem(float x, float y, float type);
void PaintSystem(bool Update);

#endif
