#ifndef gf_included_WallTile_h
#define gf_included_WallTile_h

#include "types.h"

//Simply put, any position on the board can have up to four walls.  These walls block 
//movement that come towards it.  So coming at a wall from the east or west will block
//both.  Therefore, it isn't necessary to double up walls (ie, one spot blocks east and
//the spot right next to it has a wall to block west.  One wall in either spot can serve
//that function for both spots).

struct aWallTile
{
 bool Blocks[4];  //The directions in which this spot will block incoming or outgoing tiles.
 StopType Blocking; //The stoptype is recorded for convenience, but not necessary.
 ColourType Colour;  //The colour determines the colour of ALL 4 walls.  You cannot separate different walls on the same spot.
 bool Dirty;      //If the ground for this spot stops incoming traffic.
 bool Hole;    //If there is no ground.  That means any tile that comes here will be removed.
};

typedef struct aWallTile WallTile;

WallTile MakeWallTile(StopType pBlocking);
//This function sets up the Blocks[4] as determined by the StopType.
#endif
