#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "PlayTile.h"

#ifndef gf_included_list_h
#define gf_included_list_h

//This area defines the list of play tiles which are available for any given Map.
//It's a singly-linked list.  Since the code is pretty basic, I'll only document
//anything that relates specifically to gameplay.

typedef struct Llist TList;
typedef struct tnode TNode;

struct Llist
{
 TNode* Head;
 TNode* Current;
 
 int NumCollects;  //The number of collects required before the map can switch over.
 bool GameOver;    //Is the player a failure?
 bool Winner;      //Is he a winner?
 bool GetGems;     //This is used in the switch over.  There are two phases to each map
                   //in the game.  There is before the crystals have been collected by Pid,
                   //and when the exit is collecting penguins.  If this is true, we're in phase 1.
};

struct tnode
{
 PlayTile theTile;
 int ID;
 
 TNode* next;
};

void freeTList(TList theList);
TList addNode(TList theList, PlayTile newTile);
TList removeNodes(TList theList);
TList nextNode(TList theList);
TList CreateNewTList();
TList SwitchOverCollect(TList theList);
//This function switches the list from phase 1 to phase 2.
//That means that all collectors become collectables and all collectwaits become collectors.
//All collectmewaits become collectables too (Pid's allies).
TList SwapNodes (TList theList, TNode* First, TNode* Second);
//I swap nodes for only one reason, the function that checks for interactions between tiles gave
//me back a 2.  When it does that, I gotta swap the two tiles involved in that possible interaction.
//The reason I do this is two-fold:
      //It gave me a "i dunno" because that other tile is moving.  I want to resolve that tile now.
      //After the second one is resolved, I'll eventually come across the original again and get to
      //check it. Yes, there is a possibility of an infinite loop here, but only under extreme
      //and unrealistic circumstances.
TList ResetList(TList theList);
void PrintList(TList theList);
//This function is used to simply check the setup of the list.

#endif
